REM      XREF.BAS 11.30.2000  19:00 JLD
REM PowerBasic Cross-Reference Lister - PBCC20
REM        A Public Domain Program
REM Author:John Darling, E-Mail  johnld@telocity.com
REM Latest Changes: RETURN-2, FORMATXREFLINE

'============================ META-STATEMENTS ================================

#COMPILE EXE
#DIM ALL 'added

'---------------------------- GLOBAL CONSTANTS -------------------------------

'Maximum Variables and Labels allowed in user program
  %MAX = 99999 'For DIM term$() and DIM xRef$()

  %FALSE = 0: %TRUE = NOT %FALSE
  %WHT = 7: %BWHT = 15: %YEL = 14: %RED = 12: %GRN = 10
  $TODAY = "11-30-2000"

'---------------------------- GLOBAL VARIABLES -------------------------------
  GLOBAL callLine& 'where PV, PC, PR are defined
  GLOBAL cmds$ 'PBCC2.0 keywords
  GLOBAL externals$()'Names of includes
  GLOBAL fsStart&, fsEnd&, fsLine$, fsName$ 'FUNCTION/SUB line #s and name
  GLOBAL ignoreCase& 'User FLAG 0=Case Sensitive,1=ignore upper/lower case differences
  GLOBAL indentStart& 'User FLAG Source indent start position
  GLOBAL indentSize& 'User FLAG source indenting for FOR, DO, CASE, etc
  GLOBAL insideFLAG& '0=GLOBAL AREA 1=LOCAL AREA
  GLOBAL paramFLAG& 'PR=0 PV=1 PC=2
  GLOBAL itsaLabel& 'L.
  GLOBAL keywordCase& '0=Leave alone, 1=UpperCase&
  GLOBAL term$(), xRef$()'LOCAL parameters
  GLOBAL gFS$(), gSE$(), gFSref$()'FUNCTION/SUB parameters
  GLOBAL gVar$(), gRef$()'Global Parameters
  GLOBAL labelFLAG&, gFLAG&, arrayFLAG&, fFLAG&, typeFLAG&, declareFLAG&
  GLOBAL globalFLAG&, localFLAG&, staticFLAG&
  GLOBAL lineNumber& 'Source reference line
  GLOBAL lastKeyword$
  GLOBAL maxLineLen& 'User FLAG: Use 90 if listed by PBCC editor
  GLOBAL tabSize&, tabG& 'XREF spacing
  GLOBAL terminateFLAG& 'For debug purposes

'   This allows SUB/FUNCTIONS to be forward referenced
  DECLARE FUNCTION BasParse$(BYREF source$)
  DECLARE FUNCTION Exist&(BYVAL filenam$) 'If Filename exists then FUNCTION > 0
  DECLARE FUNCTION FormatLine$(BYVAL source$)
  DECLARE FUNCTION FormatXREFLine$(BYVAL oLabel$, BYREF oRef$)
  DECLARE SUB MakeBAK(BYVAL fylename$, BYVAL suffix$)
  DECLARE SUB UpdateFS(BYVAL laybel$, BYVAL strtEnd$, BYVAL ref$)
  DECLARE SUB UpdateLocals(BYVAL laybel$, BYVAL ref$, BYREF varType$)
  DECLARE SUB UpdateGlobals(BYVAL laybel$, BYVAL ref$, BYREF varType$)
  DECLARE FUNCTION UpdateType&(BYVAL laybel$, BYVAL ref$)

'-----------------------------------------------------------------------------
FUNCTION BasParse$(BYREF source$)
' Parse the next word in a BASIC source code line
' At exit source$ contains the rest of the line.
'
  LOCAL char&, element&
  LOCAL labelKW$, kk&, vv&
  LOCAL operator$, prefix$, variable$
  LOCAL temp$, xx&, xType&, yType&, rType$

  char& = ASC(source$)
  SELECT CASE char&
    CASE - 1 'blank line
      FUNCTION = ""
      source$ = ""
      EXIT FUNCTION

'      TAB  " "
    CASE 9, 32 'white space
      FOR xx& = 1 TO LEN(source$)
        char& = ASC(source$, xx&)
        IF char& < > 9 AND char& < > 32 THEN
          FUNCTION = LEFT$(source$, xx&)
          source$ = MID$(source$, xx& + 1)
          temp$ = LEFT$(source$, xx&): GOTO FindType
        END IF
      NEXT xx&
'         '   (   )   *   +   ,   -   /   :   ;   <   =   >   \   ^
    CASE 39, 40, 41, 42, 43, 44, 45, 47, 58, 59, 60, 61, 62, 92, 94
      FUNCTION = CHR$(char&)
      IF LEN(source$) > 1 THEN
        source$ = LTRIM$(MID$(source$, 2))
      ELSE
        source$ = ""
      END IF
      temp$ = CHR$(char&): GOTO FindType
'           "
    CASE = 34 'Quote Char '"' Bundle Literal strings
      FOR xx& = 2 TO LEN(source$)
        IF MID$(source$, xx&, 1) = CHR$(34) THEN '"
          EXIT FOR
        END IF
      NEXT xx&
      IF xx& > = LEN(source$) THEN
'                  If trailing char is not a quote then put one in
        IF RIGHT$(source$, 1) < > CHR$(34) THEN source$ = source$ + CHR$(34)
        temp$ = RTRIM$(source$)
        FUNCTION = RTRIM$(source$)
        source$ = "": GOTO FindType
      ELSE
        FUNCTION = RTRIM$(LEFT$(source$, xx&))
        temp$ = RTRIM$(LEFT$(source$, xx&))
        source$ = LTRIM$(MID$(source$, xx& + 1))
        GOTO FindType
      END IF
  END SELECT
'
'                                   sp  "   '   (   )   *   +   ,   -   /   :   ;   <   =   >   \   ^
  temp$ = EXTRACT$(source$, ANY CHR$(32, 34, 39, 40, 41, 42, 43, 44, 45, 47, 58, 59, 60, 61, 62, 92, 94))

  IF LEN(temp$) = LEN(source$) THEN
    source$ = ""
  ELSE
    source$ = LTRIM$(MID$(source$, LEN(temp$) + 1))
  END IF

  IF temp$ = "?" THEN temp$ = "PRINT" 'Upgrade the short-cut print
  FUNCTION = temp$

FindType:
  rType$ = ""
  element& = 0
  operator$ = "+-*/=()\,;:<>'"
  variable$ = "$&%@?!#"
  prefix$ = "%$@&"
  labelKW$ = "GOSUBGOTOTHENELSERESUME"

  IF typeFLAG& = 10 OR declareFLAG& = 10 THEN 'ignore TYPEs and UNIONS and DECLARE SUB/F params
    element& = - 1
  ELSEIF ASC(temp$) = 46 THEN '"."
    element& = - 1 '(skip the TYPES ")."
  ELSEIF INSTR(operator$, temp$) THEN
    element& = 3: 'operator
  ELSEIF INSTR(cmds$, " " + UCASE$(temp$) + " ") THEN
    element& = 1: 'keyword
    labelFLAG& = 0
    IF INSTR(labelKW$, temp$) AND LEN(temp$) > 3 THEN 'Not TO
      IF ASC(source$) > 48 AND ASC(source$) < 58 THEN labelFLAG& = 2 '1-9
      IF ASC(source$) > 64 AND ASC(source$) < 91 THEN labelFLAG& = 20 'A-Z
      IF ASC(source$) > 96 AND ASC(source$) < 123 THEN labelFLAG& = 200 'a-z
    END IF
    IF temp$ = "LOCAL" THEN localFLAG& = 1
    IF temp$ = "GLOBAL" THEN globalFLAG& = 1
    IF temp$ = "STATIC" THEN staticFLAG& = 1
  ELSEIF VAL(temp$) > 0 OR temp$ = "0" THEN 's/b 1-6535
    element& = 2 'number
    IF labelFLAG& = 1 THEN itsaLabel& = %TRUE 'if ist char in line
    IF labelFLAG& THEN element& = 4: rType$ = "L1 "
    IF labelFLAG& = 2 THEN rType$ = "L5 "
  ELSEIF INSTR(LEFT$(temp$, 1), ANY prefix$) OR INSTR(variable$, RIGHT$(temp$, 1))THEN
    element& = 4 'constant, or variable
    IF ASC(temp$) = 36 OR ASC(temp$) = 37 THEN rType$ = "GK " '$%'
  ELSEIF (ASC(temp$) > 64 AND ASC(temp$) < 91) OR ASC(temp$) = 95 THEN 'A-Z
    element& = 5 'uppercase variable
    IF labelFLAG& = 2 THEN rType$ = "L4 "
    IF labelFLAG& = 1 AND ASC(source$) = 58 THEN itsaLabel& = %TRUE: rType$ = "L2 "
    IF labelFLAG& > 2 THEN rType$ = "L8 "
    IF typeFLAG& = 1 THEN rType$ = "GV "
    IF lastkeyword$ = "AS" THEN rType$ = "VT " 'Variable Type
  ELSEIF ASC(temp$) > 96 AND ASC(temp$) < 123 THEN 'a-z
    element& = 6 ':INCR cTR6&'lowercase variable
    IF labelFLAG& = 1 AND ASC(source$) = 58 THEN itsaLabel& = %TRUE: rType$ = "L3 "
    IF labelFLAG& > 2 THEN rType$ = "L9 "
    IF typeFLAG& = 1 THEN rType$ = "GV "
    IF lastkeyword$ = "AS" THEN rType$ = "VT " 'Variable Type
  ELSEIF LEFT$(temp$, 1) = "#" THEN
    element& = 2 'Filenumber or constant
  ELSEIF LEFT$(temp$, 1) = CHR$(34) THEN
    element& = 7 'string constant
  ELSEIF LEFT$(temp$, 1) = "#" THEN
    element& = 8 'meta-statement or file number
  ELSEIF INSTR(temp$, ".") THEN 'Complex TYPE
    element& = 4
  END IF

  kk& = 0
  IF element& = 1 AND (temp$ = "#INCLUDE" OR temp$ = "$INCLUDE") THEN
    kk& = 1
    DO WHILE externals$(kk&) < > ""
      kk& = kk& + 1
    LOOP
    externals$(kk&) = TRIM$(source$, CHR$(34))
    vv& = INSTR(externals$(kk&), CHR$(34))
    IF vv& THEN externals$(kk&) = LEFT$(externals$(kk&), vv& - 1)
'''        PRINT                                     '''
'''        PRINT source$,kk&                         '''
'''        PRINT externals$(kk&): WAITKEY$           '''
    externals$(0) = STR$(kk&)
  END IF

  IF LEFT$(temp$, 1) = "&" THEN element& = 2 '&B1010 or %H0FF

  SELECT CASE element&
    CASE - 1 'skip Complex array TYPES
    CASE 0
      COLOR %RED: PRINT
      PRINT " Problem processing Linenumber" lineNumber& ".  Check source code."
      PRINT " XREF did not recognize the data type in that line."
      PRINT "           Hit any key to continue."
      terminateFLAG& = 1
      COLOR %WHT: WAITKEY$: CURSOR ON: EXIT FUNCTION
    CASE 4 TO 6 'add more cases
      IF rType$ = "VT " THEN
        PRINT ""; '''may need explanation later
      ELSEIF localFLAG& = 1 THEN
        rType$ = ".V "
      ELSEIF globalFLAG& = 1 THEN
        rType$ = "GV "
      ELSEIF staticFLAG& = 1 THEN
        rType$ = "SV "
      ELSEIF arrayFLAG& THEN
        rType$ = ".V "
      END IF

      IF ASC(source$) = 40 THEN '"(" Indicate Functions & arrays
        temp$ = temp$ + "()": fFLAG& = 1
        xType& = INSTR(source$, ").")
        IF xType& THEN 'Eg: HC(rec).player.score$
          yType& = INSTR(xType& + 1, source$, ANY operator$ + variable$)
          temp$ = temp$ + MID$(source$, xType& + 1, yType& - xType&)
        END IF
      END IF

      IF LEN(temp$) > tabSize& THEN tabSize& = LEN(temp$)

'When inside a FUNCTION/SUB update LOCALS otherwise GLOBALS
      IF insideFLAG& = 1 THEN
        CALL UpdateLocals(temp$, STR$(lineNumber&), rType$)
      ELSEIF insideFLAG& = 0 THEN
        IF declareFLAG& = 3 THEN rType$ = "S. "
        IF declareFLAG& = 2 THEN rType$ = "F. "
        CALL UpdateGlobals(temp$, STR$(lineNumber&), rType$)
      END IF
  END SELECT

  IF element& < > 1 AND labelFLAG& THEN labelFLAG& = %FALSE

'                   Update Global Variables
  IF ASC(temp$) = 36 AND element& < > 1 THEN 'except for $DQ ... String equates  was <> 1
    IF INSTR(source$, "=") = 0 THEN CALL UpdateGlobals(temp$, STR$(lineNumber&), "GK ")
  END IF

'Update FUNCTION/SUB References, include arrays
  IF fFLAG& = 1 AND temp$ < > fsName$ THEN
    CALL UpdateFS(temp$, "", STR$(lineNumber&))
  END IF
  fFLAG& = 0
END FUNCTION

'-----------------------------------------------------------------------------
FUNCTION Exist&(BYVAL filenam$) 'If Filename exists then FUNCTION > 0
  FUNCTION = LEN(DIR$(filenam$))> 0
END FUNCTION

'-----------------------------------------------------------------------------
FUNCTION FormatLine$(BYVAL source$)
'Source$ = original line
'output = reformatted (indented and uniformly spaced

  LOCAL keyword$, rest$
  LOCAL ii&, newLine$, original$, temp$, tempLine$
  LOCAL tempStart&, tmp&, tt$, work$
  LOCAL rType$

  STATIC inComment&
'                                   tab,space
  original$ = TRIM$(source$, ANY CHR$(9, 32))
'  work$ = UCASE$(original$) 'May need to restore this with keyword$
  work$ = original$
  tempStart& = - 1

  globalFLAG& = 0: localFLAG& = 0: staticFLAG& = 0

  IF LEN(work$) = 0 THEN
    EXIT FUNCTION
  END IF

  keyword$ = UCASE$(EXTRACT$(work$, ANY " ,="))
'  keyword$ = EXTRACT$(work$, ANY " ,=")

  rest$ = REMAIN$(work$, ANY " ,=")

  IF inComment& = %TRUE THEN
    FUNCTION = source$
    EXIT FUNCTION
'                                  added
  ELSEIF UCASE$(LEFT$(work$, 4))= "#IF " OR UCASE$(LEFT$(work$, 4))= "$IF " THEN
    inComment& = %TRUE
    tempStart& = 0
    GOTO ExtendLine
'                   added
  ELSEIF keyword$ = "#ENDIF" OR keyword$ = "$ENDIF" THEN
    inComment& = %FALSE
    tempStart& = 0
    GOTO ExtendLine
'                       '
  ELSEIF (ASC(work$) = 39) OR (UCASE$(LEFT$(work$, 3))= "REM") THEN
    FUNCTION = original$ 'was source$
    EXIT FUNCTION
'                       !
  ELSEIF (ASC(work$) = 33) OR (UCASE$(LEFT$(work$, 3))= "ASM") THEN
    FUNCTION = source$ 'don't mess with ASM lines
    EXIT FUNCTION

  ELSEIF keyword$ = "DATA" THEN 'don't mess with DATA statements
    FUNCTION = source$
    EXIT FUNCTION
'                                        ***** search key
  ELSEIF LEFT$(keyword$, 3) = "DEF" THEN 'don't mess with DEFLNG, DEFINT, etc
    IF INSTR(UCASE$(cmds$), UCASE$(" " + keyword$ + " "))> 0 THEN
      FUNCTION = source$
      EXIT FUNCTION
    END IF
'                       #                    $
  ELSEIF (ASC(work$) = 35) THEN 'Both meta-statements
    tempStart& = 0
    GOTO ExtendLine
'                       $
  ELSEIF (ASC(work$) = 36) AND (INSTR(rest$, "=") = 0) THEN 'for PBCC 1.0 Not a Global constant
    tempStart& = 0 'verify this
    GOTO ExtendLine
  END IF

'Try and distinguish between arrays and functions  'nnnn()
'       Perhaps move this to BasParse() ~ line 163
  arrayFLAG& = INSTR("DIM REDIM GLOBAL LOCAL STATIC", keyword$)

  IF keyword$ = "IF" THEN
    tmp& = INSTR(UCASE$(work$), "THEN")

    IF (tmp& + 3) = LEN(work$) THEN
      tempStart& = indentStart&
      indentStart& = indentStart& + indentSize&
      GOTO ExtendLine
    END IF

    temp$ = LTRIM$(MID$(work$, tmp& + 4))
    IF ASC(temp$) = 39 THEN '
      tempStart& = indentStart&
      indentStart& = indentStart& + indentSize&
      GOTO ExtendLine
    END IF

    GOTO ExtendLine
  END IF

  IF (keyword$ = "ELSE") OR (keyword$ = "ELSEIF") THEN
    tmp& = indentStart& - indentSize&
    IF tmp& < 0 THEN
      tmp& = 0
    END IF
    tempStart& = tmp&
    GOTO ExtendLine
  END IF

  IF keyword$ = "RETURN" THEN
    tmp& = indentStart& - indentSize&
    IF tmp& < 0 THEN
      tmp& = 0
    END IF
    tempStart& = tmp&
    GOTO ExtendLine
  END IF

  IF keyword$ = "END" THEN
    temp$ = UCASE$(work$)
    IF (INSTR(temp$, "IF") = 5) OR (INSTR(temp$, "TYPE") = 5) OR (INSTR(temp$, "UNION") = 5) THEN
      typeFLAG& = 0
      indentStart& = indentStart& - indentSize&
      GOTO ExtendLine
    ELSEIF (INSTR(temp$, "SUB") = 5) OR (INSTR(temp$, "FUNCTION") = 5) THEN
      indentStart& = 0
      fsEnd& = lineNumber&: insideFLAG& = 0
      fsLine$ = fsLine$ + FORMAT$(fsEnd&, "#####") 'max line#=99999
      gFLAG& = 1 'print Global sub
      GOSUB SaveXREF
    ELSEIF INSTR(temp$, "SELECT") = 5 THEN
      indentStart& = indentStart& - indentSize&
      indentStart& = indentStart& - indentSize&
      GOTO ExtendLine
    END IF
  END IF

  IF keyword$ = "STATIC" OR keyword$ = "CALLBACK" THEN
    staticFLAG& = 2 'Function = default
    IF LEFT$(rest$, 3) = "SUB" THEN
      staticFLAG& = 3 'SUB
      fsName$ = EXTRACT$(5, rest$, ANY " (") + "()"
      rType$ = "S. ": insideFLAG& = 1
      fsLine$ = rType$ + FORMAT$(fsStart&, " #####-")
      tempStart& = 0
      indentStart& = indentSize&
      fsStart& = lineNumber&: callLine& = 1
      GOTO ExtendLine
    ELSEIF LEFT$(rest$, 8) = "FUNCTION" THEN
      fsName$ = EXTRACT$(10, rest$, ANY " (") + "()"
      rType$ = "F. ": insideFLAG& = 1
      fsLine$ = rType$ + FORMAT$(fsStart&, " #####-")
      tempStart& = 0
      indentStart& = indentSize&
      fsStart& = lineNumber&: callLine& = 1
      GOTO ExtendLine
    END IF
  ELSEIF keyword$ = "DECLARE" THEN
    IF MID$(work$, 9, 3) = "SUB" THEN declareFLAG& = 3
    IF MID$(work$, 9, 8) = "FUNCTION" THEN declareFLAG& = 2
  ELSEIF keyword$ = "SUB" THEN
    tempStart& = 0
    indentStart& = indentSize&
    fsStart& = lineNumber&: callLine& = 1
    fsName$ = EXTRACT$(rest$, ANY " (") + "()"
    rType$ = "S. "
    fsLine$ = rType$ + FORMAT$(fsStart&, " #####-")
    insideFLAG& = 1
    GOTO ExtendLine

  ELSEIF (keyword$ = "FUNCTION") AND (INSTR(work$, "=") = 0) THEN
    tempStart& = 0
    indentStart& = indentSize&
    fsStart& = lineNumber&: callLine& = 1
    fsName$ = EXTRACT$(rest$, ANY " (") + "()"
    rType$ = "F. "
    fsLine$ = rType$ + FORMAT$(fsStart&, " #####-")
    insideFLAG& = 1
    GOTO ExtendLine
  END IF

  IF keyword$ = "TYPE" OR keyword$ = "UNION" THEN
    typeFLAG& = 1
    tempStart& = indentStart&
    indentStart& = indentStart& + indentSize&
    GOTO ExtendLine
  END IF

  IF keyword$ = "SELECT" THEN
    tempStart& = indentStart&
    indentStart& = indentStart& + indentSize&
    indentStart& = indentStart& + indentSize&
    GOTO ExtendLine
  END IF

  IF keyword$ = "CASE" THEN
    tmp& = indentStart& - indentSize&
    IF tmp& < 0 THEN tmp& = 0
    tempStart& = tmp&
    GOTO ExtendLine
  END IF

  IF keyword$ = "FOR" THEN
    IF INSTR(work$, "NEXT") = 0 THEN
      tempStart& = indentStart&
      indentStart& = indentStart& + indentSize&
      GOTO ExtendLine
    END IF
  ELSEIF keyword$ = "NEXT" THEN
    indentStart& = indentStart& - indentSize&
    GOTO ExtendLine
  END IF

  IF keyword$ = "WHILE" THEN
    IF INSTR(work$, "WEND") = 0 THEN
      tempStart& = indentStart&
      indentStart& = indentStart& + indentSize&
      GOTO ExtendLine
    END IF
  ELSEIF keyword$ = "WEND" THEN
    indentStart& = indentStart& - indentSize&
    GOTO ExtendLine
  END IF

  IF keyword$ = "DO" THEN
    IF INSTR(work$, "LOOP") = 0 THEN
      tempStart& = indentStart&
      indentStart& = indentStart& + indentSize&
      GOTO ExtendLine
    END IF
  ELSEIF keyword$ = "LOOP" THEN
    indentStart& = indentStart& - indentSize&
    GOTO ExtendLine
  END IF

ExtendLine:
  IF tempStart& = - 1 THEN
    newLine$ = SPACE$(indentStart&)
  ELSE
    newLine$ = SPACE$(tempStart&)
  END IF

  tempLine$ = original$
  WHILE LEN(tempLine$)
    keyword$ = BasParse$(tempLine$)
    IF terminateFLAG& THEN EXIT FUNCTION

    IF itsaLabel& = %TRUE THEN
      FUNCTION = original$
      itsaLabel& = %FALSE
      EXIT FUNCTION
    END IF

    IF keywordCase& > 0 THEN
      IF INSTR(UCASE$(cmds$), UCASE$(" " + keyword$ + " "))> 0 THEN
        IF keywordCase& = 1 THEN 'upper case  BEST OPTION
          keyword$ = UCASE$(keyword$)
        ELSE
'leave KEYWORD alone (POOR OPTION)
        END IF
      END IF
    END IF

    IF keyword$ = "'" THEN
      newLine$ = newLine$ + keyword$ + tempLine$
      EXIT DO
    ELSEIF (keyword$ = ",") OR (keyword$ = ";") OR (keyword$ = ":") THEN
      newLine$ = RTRIM$(newLine$) + keyword$ + " "
    ELSEIF keyword$ = "-" THEN
      IF lastKeyword$ = "(" THEN
        tt$ = BasParse$(tempLine$)
        newLine$ = newLine$ + keyword$ + tt$ + " "
      ELSEIF (INSTR("+=/\<>*^-", lastKeyword$))AND (INSTR(tempLine$, ANY "0123456789") < 0) THEN
        tt$ = BasParse$(tempLine$)
        newLine$ = newLine$ + keyword$ + tt$ + " "
      ELSE
        newLine$ = newLine$ + keyword$ + " "
      END IF
    ELSEIF keyword$ = "(" THEN
      IF (INSTR("-+/\*^<>=", lastKeyword$) > 0) OR (INSTR("ELSEIFANDXORMOD", lastKeyword$) > 0) THEN
        newLine$ = newLine$ + keyword$ + ""
      ELSE
        newLine$ = RTRIM$(newLine$) + keyword$ + ""
      END IF
    ELSEIF keyword$ = ")" THEN
      IF INSTR("()", lastKeyword$) THEN
        newLine$ = RTRIM$(newLine$) + keyword$ + ""
      ELSEIF ASC(tempLine$) = 46 THEN '. (period)
        newLine$ = RTRIM$(newLine$) + keyword$
      ELSE
        newLine$ = RTRIM$(newLine$) + keyword$ + " "
      END IF
    ELSE
      newLine$ = newLine$ + keyword$ + " "
    END IF
    lastKeyword$ = UCASE$(keyword$)
  WEND

  FUNCTION = RTRIM$(newLine$)
  EXIT FUNCTION

SaveXREF: 'Save the individual FUNCTION/SUB XREF after "END FUNCTION/SUB
  OPEN "XREF.TMP" FOR APPEND AS #9 'Temp file - Remove it later
  PRINT# 9, "FUNCTION/SUB: " fsName$, fsLine$
  FOR ii& = 1 TO VAL(term$(0))'nLabels& 'copy term$()& xRef$()
    PRINT# 9, term$(ii&); " "; xRef$(ii&) 'Needs to be formatted
  NEXT ii&
  PRINT# 9, ""
  CLOSE #9

  REDIM term$(%MAX), xRef$(%MAX)
  term$(0) = STR$(0)
RETURN

END FUNCTION

'----------------------------------------------------------------------
FUNCTION FormatXREFLine$(BYVAL oLabel$, BYREF oRef$)
'    output is Formatted XREF output lines

  LOCAL oLine$, sp&, xR$, yR$, ii&, kk&, ref$, found&, xLabel$, pad&
  STATIC incFLAG&

  IF ASC(oRef$) = 32 THEN 'not GK,GV,F.,S. etc
    found& = UpdateType&(oLabel$, oRef$)
    IF found& = 0 AND incFLAG& = 0 THEN GOSUB SearchINC 'Try externals (adds  X. or XV if found)
  END IF

  IF tabSize& = 0 THEN tabSize& = LEN(oLabel$) + 2 'This should never happen
  IF maxLineLen& = 0 THEN maxLineLen& = 100 'This should never happen

  pad& = 0
  oLine$ = oLabel$ + SPACE$(tabSize& + 1 - LEN(oLabel$))
LLoop:
'                     100           13        25
  IF LEN(oRef$) = > maxLineLen& - tabSize& - pad& THEN
    sp& = INSTR(-1, LEFT$(oRef$, maxLineLen& - tabSize& - pad&), " ")
    IF sp& = 0 THEN
      PRINT "oops!": WAITKEY$: EXIT FUNCTION
      xR$ = LEFT$(oRef$, maxLineLen& - tabSize& - 4)
      yR$ = MID$(oRef$, maxLineLen& - tabSize& - 3)
    ELSE
      xR$ = LEFT$(oRef$, sp&)
      yR$ = MID$(oRef$, sp& + 1)
      pad& = tabG& + 5 + 3 * (tabG& > 0)
    END IF
    oLine$ = oLine$ + xR$ + $CRLF
    oRef$ = TRIM$(yR$)
    oLine$ = oLine$ + SPACE$(tabSize& + pad&)
    GOTO LLoop
  ELSE
    oLine$ = oLine$ + oRef$
  END IF
  FUNCTION = oLine$
  EXIT FUNCTION

SearchINC:
'Look in the INCLUDES for undefined references (X and XV)
  IF RIGHT$(oLabel$, 2) = "()" THEN
    xLabel$ = LEFT$(oLabel$, LEN(oLabel$) - 2)
  ELSE
    xLabel$ = oLabel$
  END IF
  ii& = 1: found& = 0
  DO UNTIL externals$(ii&) = "" OR found& = 1
    IF Exist&(externals$(ii&))= 0 THEN
      COLOR %RED: PRINT CHR$(34); externals$(ii&); CHR$(34);
      PRINT " does not exist in this directory": incFLAG& = 1: EXIT FUNCTION
    ELSE
      OPEN externals$(ii&) FOR INPUT AS #5
      WHILE NOT EOF(5)
        LINE INPUT# 5, ref$ 'external reference line
        IF INSTR(UCASE$(ref$), UCASE$(xLabel$))THEN
          found& = 1
          IF INSTR(ref$, "SUB") THEN
            oRef$ = "XS " + oRef$
          ELSEIF INSTR(ref$, "FUNCTION") THEN
            oRef$ = "XF " + oRef$
          ELSE
            IF LEFT$(oRef$, 3) = "GV " THEN
              oRef$ = MID$(oRef$, 4) 'remove GV
              oRef$ = "XV " + oRef$
            ELSEIF LEFT$(oRef$, 3) = "GK " THEN
              oRef$ = MID$(oRef$, 4) 'remove GK
              oRef$ = "XK" + oRef$
            END IF
          END IF
          EXIT DO '1st not 2nd
        END IF
      WEND
      CLOSE 5
      IF found& THEN EXIT DO 'exit 2nd
    END IF
    ii& = ii& + 1
  LOOP
RETURN

END FUNCTION

'-----------------------------------------------------------------------------
SUB MakeBAK(BYVAL fylename$, BYVAL suffix$)
' MakeBAK - Rename a file with an extension defined by suffix$
'           fylename$ = Name of input file to rename.
'
  LOCAL bak$, dot&
  bak$ = fylename$

  dot& = INSTR(bak$, ".") '***  Add suffix extension  ***
  IF dot& = 0 THEN
    bak$ = bak$ + "." + suffix$
  ELSE
    bak$ = LEFT$(bak$, dot&) + suffix$
  END IF

  IF Exist&(bak$) THEN '***  If .BAK file already Exist&s, kill it  ***
    KILL bak$
  END IF

  NAME fylename$ AS bak$ '***  Rename file  ***
END SUB

'-----------------------------------------------------------------------------
FUNCTION PBMAIN&()
  DIM term$(%MAX), xRef$(%MAX) 'LOCAL label and REF
  DIM gFS$(%MAX \ 10), gSE$(%MAX \ 10), gFSref$(%MAX \ 10) 'AS GLOBAL FUNCTION/SUBS Area
  DIM gVar$(%MAX), gRef$(%MAX) 'Global label and ref
  DIM externals$(%MAX \ 10) 'Include filenames

  LOCAL bytesRead&, percent&
  LOCAL erCode&, fLabel$, fRef$
  LOCAL ii&, inFile$, outFile$, inFileDEF$
  LOCAL formatFLAG&, xdef$
  LOCAL sp&, spX&, temp1$, temp2$, title$, xRefFile$
  LOCAL nLabels&, tLabels&, tempTab&
  LOCAL xR$, yR$, rawLine$, t1&, t2&

  ON ERROR GOTO ErrorHandler 'Trap Errors

  CONSOLE SCREEN 20, 100 'Speed up execution
  CLS
'------------------------ USER PREFERENCE LIST ----------------------
'THESE PARAMETERS CAN BE SET IN "XREF.DEF" AS A PROGRAMMING CONVENIENCE

'1.For .TST Listing
  indentStart& = 2 'start column for indenting
'              = 0 'also ok

  indentSize& = 2 'number of spaces to indent
'             = 3 'also ok

  keywordCase& = 1 'convert keywords to upper case (good)
'                0 'don't change keyword case      (ok)

  formatFLAG& = 0 'Keep original source code (.TST->.BAK,             .TST->0)
'             = 1 'Use reformatted .TST file (.BAS->.BAK, .TST->.BAS, .TST->0)

'2.For .REF Listing

  ignoreCase& = 0 'Case Sensitive (show different spellings)
'             = 1 'References NOT case sensitive

  maxLineLen& = 100 'Typical for portrait printout using fontSize of  9 or less
'             = 85  'Typical for PBCC Editor (CCEDIT) Printout
'             = 135 'Typical for landscape printout using fontSize of 9 or less
'             = 70  'Typical for printout using fontSize of 13 or less
'---------------------------------------------------------------------
  t1& = TIMER 'start time
  nLabels& = 0 'Individual Number of labels found in each FUNCTION/SUB
  tLabels& = 0 'Total Number of labels found
  tabSize& = 5 'CROSS-REFERENCE LABEL SIZE
'              (This will be adjusted to be 2 > longest cross-reference variable)
  xdef$ = "not"
  IF Exist&("XREF.DEF") THEN 'User defined options
    PRINT SPACE$(10); "The user options from XREF.DEF were used"

    OPEN "XREF.DEF" FOR INPUT AS #1
    xdef$ = "is"
    WHILE NOT EOF(1)
      LINE INPUT #1, rawLine$
      IF ASC(rawLine$) = 39 THEN 'Comment Line
        ITERATE DO 'Ignore comment lines
      ELSEIF LEFT$(UCASE$(rawLine$), 5) = "XREF " THEN
        sp& = INSTR(6, rawLine$, ANY " '")
        IF sp& THEN
          inFileDEF$ = MID$(rawline$, 6, sp& - 6)
        ELSE
          inFileDEF$ = MID$(rawLine$, 6)
        END IF
      ELSEIF INSTR(UCASE$(rawLine$), "FORMATFLAG&") THEN
        xR$ = REMAIN$(rawLine$, "=")
        yR$ = EXTRACT$(xR$, "'")
        formatFLAG& = VAL(yR$)
      ELSEIF INSTR(UCASE$(rawLine$), "INDENTSTART&") THEN
        xR$ = REMAIN$(rawLine$, "=")
        yR$ = EXTRACT$(xR$, "'")
        indentStart& = VAL(yR$)
      ELSEIF INSTR(UCASE$(rawLine$), "INDENTSIZE&") THEN
        xR$ = REMAIN$(rawLine$, "=")
        yR$ = EXTRACT$(xR$, "'")
        indentSize& = VAL(yR$)
      ELSEIF INSTR(UCASE$(rawLine$), "IGNORECASE&") THEN
        xR$ = REMAIN$(rawLine$, "=")
        yR$ = EXTRACT$(xR$, "'")
        ignoreCase& = VAL(yR$)
      ELSEIF INSTR(UCASE$(rawLine$), "MAXLINELEN&") THEN
        xR$ = REMAIN$(rawLine$, "=")
        yR$ = EXTRACT$(xR$, "'")
        maxLineLen& = VAL(yR$)
      ELSEIF INSTR(UCASE$(rawLine$), "KEYWORDCASE&") THEN
        xR$ = REMAIN$(rawLine$, "=")
        yR$ = EXTRACT$(xR$, "'")
        keywordCase& = VAL(yR$)
      END IF
    WEND
    CLOSE
  END IF

  CURSOR OFF
  COLOR %BWHT: PRINT
  PRINT "PB/CC2.0 Source Code Formatter and Cross Reference Lister. "
  PRINT $TODAY; " (a Public Domain Program): Author: John Darling "
  PRINT

  inFile$ = UCASE$(COMMAND$) 'Use this line for external usage
' inFile$ = "XREFB30.BAS"    'Use this technique to check out internally

'***  Check for filename on command line  ***
  IF LEN(inFile$) = 0 AND inFileDEF$ = "" THEN
    PRINT "Usage:  XREF filename.ext"
    BEEP: CURSOR ON: WAITKEY$
    EXIT FUNCTION
  ELSEIF LEN(inFile$) = 0 THEN 'otherwise use file in XREF.DEF
    inFile$ = inFileDEF$
  END IF

'***  Assume a .BAS extension  ***
  IF INSTR(inFile$, ".") = 0 THEN
    inFile$ = inFile$ + ".BAS" 'also .INC
    outFile$ = inFile$ + ".TST"
  ELSE
    outFile$ = EXTRACT$(inFile$, ".") + ".TST"
  END IF

  xRefFile$ = EXTRACT$(outFile$, ".") + ".REF"

'***  Make sure it Exist&s  ***
  IF NOT Exist&(inFile$) THEN
    PRINT inFile$ " File Not Found."
    BEEP: CURSOR ON: WAITKEY$
    EXIT FUNCTION
  END IF

'***  Open file and process it  ***
  OPEN inFile$ FOR INPUT AS #1
  OPEN outFile$ FOR OUTPUT AS #2

  COLOR %YEL: PRINT "INPUT : Original    ";
  COLOR %BWHT: PRINT inFile$ ';
  COLOR %YEL: PRINT "OUTPUT: Reformatted ";
  COLOR %BWHT: PRINT outFile$;
  COLOR %YEL: PRINT "    and     ";
  COLOR %BWHT: PRINT xRefFile$;
  COLOR %YEL: PRINT " for XREF Listing": COLOR %WHT
  PRINT
'                              Total PBCC20 Keywords: 441+12
  cmds$ = ""
'                           PowerBASIC metastatements FOR CC2.0 only
  cmds$ = cmds$ + " #COMPILE #DEBUG #DIM #ELSE #ELSEIF #ENDIF #IF #INCLUDE #OPTION #REGISTER "
  cmds$ = cmds$ + " #RESOURCE #SEGMENT #STACK "

'                           PowerBASIC metastatements FOR CC1.0 and 2.0
  cmds$ = cmds$ + " $COMPILE $DEBUG $DIM $ELSE $ELSEIF $ENDIF $IF $INCLUDE $OPTION $REGISTER "
  cmds$ = cmds$ + " $RESOURCE $SEGMENT $STACK "

'        PowerBASIC CC2.0 pre-defined equates 'remove Comment if not wanted in .REF listing
'  cmds$ = cmds$ + " $BEL $BS $CR $CRLF $DQ $EOF $ESC $FF $LF $NUL $TAB $VT "

  cmds$ = cmds$ + " %DEF "

  cmds$ = cmds$ + " ABS ACCEPT ACCESS ADDR ALIAS ALL AND ANY APPEND ARRAY AS ASC ASCEND ASCIIZ "
  cmds$ = cmds$ + " ASM AT ATN ATTACH ATTRIB "
  cmds$ = cmds$ + " BASE BAUD BDECL BEEP BIN$ BINARY BIT BITS% BITS& BITS? BITS?? BITS??? "
  cmds$ = cmds$ + " BREAK BYCOPY BYREF BYTE BYVAL "
  cmds$ = cmds$ + " CALL CASE CBYT CCUR CCUX CD CDBL CDECL CDWD CEIL CEXT CHDIR CHDRIVE CHR$ "
  cmds$ = cmds$ + " CINT CLNG CLOSE CLS CODEPTR COLLATE COLOR COMM COMMAND$ CON CONSIN CONSNAME$ "
  cmds$ = cmds$ + " CONSOLE CONSOUT COS CQUD CREATE CSNG CTSFLOW CUR CURDIR$ CURRENCY CURRENCYX "
  cmds$ = cmds$ + " CURSOR CURSORX CURSORY CUX CVBYT CVCUR CVCUX CVD CVDWD CVE CVI CVL CVQ "
  cmds$ = cmds$ + " CVS CVWRD CWRD "
  cmds$ = cmds$ + " DATA DATACOUNT DATE$ DECLARE DECR DEFAULT DEFBYT DEFCUR DEFCUX DEFDBL "
  cmds$ = cmds$ + " DEFDWD DEFEXT DEFINT DEFLNG DEFQUD DEFSNG DEFSTR DEFWRD DELETE DESCEND "
  cmds$ = cmds$ + " DIM DIR$ DISKFREE DISKSIZE DLL DO DOUBLE DOWN DSRFLOW DSRSENS DTRFLOW "
  cmds$ = cmds$ + " DTRLINE DWORD "
  cmds$ = cmds$ + " ELSE ELSEIF END ENVIRON$ EOF EQV ERASE ERR ERRAPI ERRCLEAR ERROR EXE "
  cmds$ = cmds$ + " EXIT EXP EXP10 EXP2 EXPLICIT EXPORT EXT EXTENDED EXTERNAL EXTRACT$ "
  cmds$ = cmds$ + " FAR FILEATTR FILECOPY FILENAME$ FIX FLUSH FOR FORMAT$ FORMFEED FRAC FREEFILE "
  cmds$ = cmds$ + " FROM FUNCTION "
  cmds$ = cmds$ + " GET GET$ GETATTR GETSTDERR GETSTDIN GETSTDOUT GLOBAL GOSUB GOTO "
  cmds$ = cmds$ + " HANDLE HEX$ HIBYT HIWRD HOST "
  cmds$ = cmds$ + " IDN IF IMP IN INCR INKEY$ INPUT INPUT# INSERT INSHIFT INSTAT INSTR INT "
  cmds$ = cmds$ + " INTEGER INV ISFALSE ISTRUE ITERATE "
  cmds$ = cmds$ + " KILL "
  cmds$ = cmds$ + " LBOUND LCASE$ LEFT LEFT$ LEN LET LIB LINE LOBYT LOC LOCAL LOCATE LOCK "
  cmds$ = cmds$ + " LOF LOG LOG10 LOG2 LONG LOOP LOWRD LPRINT LPRINT$ LSET LTRIM$ "
  cmds$ = cmds$ + " MAKDWD MAKLNG MAKPTR MAT MAX MAX$ MAX% MAX& MCASE$ MID$ MIN MIN$ MIN% "
  cmds$ = cmds$ + " MIN& MKBYT$ MKCUR$ MKCUX$ MKD$ MKDIR MKDWD$ MKE$ MKI$ MKL$ MKQ$ MKS$ "
  cmds$ = cmds$ + " MKWRD$ MOD MOUSE MOUSEBUTTONS MOUSESTAT MOUSEX MOUSEY MOVE "
  cmds$ = cmds$ + " NAME NEXT NONE NOT NOTIFY NULL "
  cmds$ = cmds$ + " OCT$ OF OFF ON OPEN OPTION OR OUTPUT "
  cmds$ = cmds$ + " PAGE PARITY PARITYCHAR PARITYREPL PARITYTYPE PARSE$ PARSECOUNT PBD PBDEBUG "
  cmds$ = cmds$ + " PBMAIN PCOPY PEEK PEEK$ POINTER POKE POKE$ PORT PRESERVE PRINT PRINT# "
  cmds$ = cmds$ + " PRIVATE PTR PUBLIC PUT PUT$ "
  cmds$ = cmds$ + " QUAD "
  cmds$ = cmds$ + " RANDOM RANDOMIZE READ READ$ RECV REDIM REGEXPR REGISTER REGREPL REM REMAIN$ "
  cmds$ = cmds$ + " REMOVE$ REPEAT$ REPLACE RESET RESUME RET16 RET32 RET87 RETP16 RETP32 "
  cmds$ = cmds$ + " RETPRM RETURN RGB RIGHT RIGHT$ RING RLSD RMDIR RND ROTATE ROUND RSET "
  cmds$ = cmds$ + " RTRIM$ RTSFLOW RXBUFFER RXQUE "
  cmds$ = cmds$ + " SCAN SCREEN SCREENATTR SCREENX SCREENY SCROLL SDECL SEEK SELECT SEND "
  cmds$ = cmds$ + " SET SETATTR SETEOF SGN SHARED SHELL SHIFT SIGNED SIN SINGLE SIZEOF SLEEP "
  cmds$ = cmds$ + " SORT SPACE$ SPC SQR STATIC STATUS STDCALL STDEOF STDERR STDIN STDOUT "
  cmds$ = cmds$ + " STEP STOP STR$ STRDELETE$ STRING STRING$ STRINSERT$ STRPTR STRREVERSE$ "
  cmds$ = cmds$ + " SUB SUSPEND SWAP "
  cmds$ = cmds$ + " TAB TAGARRAY TALLY TAN TCP THEN THREAD TIME$ TIMEOUT TIMER TO TOGGLE "
  cmds$ = cmds$ + " TRIM$ TRN TXBUFFER TXQUE TYPE "
  cmds$ = cmds$ + " UBOUND UCASE UCASE$ UDP UNION UNLOCK UNTIL UP USING "
  cmds$ = cmds$ + " VAL VARPTR VERIFY VERSION3 VERSION4 VERSION5 "
  cmds$ = cmds$ + " WAITKEY$ WAITSTAT WEND WHILE WIDTH WITH WORD WRITE WRITE# "
  cmds$ = cmds$ + " XINPFLOW XOR XOUTFLOW "
  cmds$ = cmds$ + " ZER "

'----------------------------------------------------------

  OPEN xRefFile$ FOR OUTPUT AS #3

  title$ = "Cross Reference Listing for " + inFile$
  PRINT# 3, SPACE$(25); title$
  PRINT# 3, SPACE$(25); STRING$(LEN(title$), "-")
  PRINT# 3, SPACE$(10) "Note: The UNDERSCORE character is removed from the original source code  "
  PRINT# 3, SPACE$(10) "      and replaced when lines exceeds the maximum length (maxLineLength&)"
  PRINT# 3, "To keep original source intact: set formatFLAG&=0 in XREF.DEF or XREF.BAS, line 687."
  PRINT# 3, STRING$(84, "~"): PRINT# 3, ""

  IF Exist&("XREF.TMP") THEN KILL "XREF.TMP" 'Otherwise APPEND gets messed up.

  insideFLAG& = 0
  WHILE NOT EOF(1)
    LINE INPUT# 1, temp1$ 'source Line
UnderScoreLines:  'Combine underscore lines into one line, other wise some variables get lost
    IF RIGHT$(temp1$, 1) = "_" THEN
      temp1$ = RTRIM$(temp1$, "_")
      LINE INPUT# 1, temp2$
      temp1$ = temp1$ + temp2$
      GOTO UnderScoreLines
    END IF

    lineNumber& = lineNumber& + 1
    bytesRead& = bytesRead& + LEN(temp1$) + 2
    percent& = (bytesRead& * 100) \ LOF(1)
    LOCATE, 1: PRINT FORMAT$(percent&); "% Done";

    labelFLAG& = 1: declareFLAG& = 0: callLine& = 0
    IF typeFLAG& = 1 THEN typeFLAG& = 10 'ignore 2nd line thru END TYPE line

    temp1$ = FormatLine$(temp1$) 'Original line in, reformatted line out
    PRINT# 2, temp1$

    IF gFLAG& = 1 THEN
      CALL UpdateFS(fsName$, fsLine$, STR$(fsStart&))
      gFLAG& = 0
    END IF
    IF terminateFLAG& THEN CLOSE: GOTO 100 '%MAX exceeded

    PRINT# 3, FORMAT$(lineNumber&, "##### "); 'modify for programs >99999 lines
LLoop0:
    IF LEN(temp1$) > maxLineLen& - 6 THEN 'was =>
      sp& = INSTR(maxLineLen& - 6, temp1$, " ")
      IF sp& = 0 THEN
        xR$ = LEFT$(temp1$, maxLineLen& - 8)
        spX& = INSTR(-1, temp1$, " ")
        IF spX& = 0 THEN
          yR$ = MID$(temp1$, maxLineLen& - 7)
        ELSE
          xR$ = LEFT$(temp1$, spX&)
          yR$ = MID$(temp1$, spX& + 1)
        END IF
      ELSE
        xR$ = LEFT$(temp1$, sp&)
        yR$ = MID$(temp1$, sp& + 1)
      END IF
      PRINT# 3, xR$; "_" 'Use underscore to extend long lines to next line
      PRINT# 3, SPACE$(6);
      temp1$ = yR$
      GOTO LLoop0
    ELSE
      PRINT# 3, temp1$
    END IF
  WEND
  CLOSE 2: CLOSE 1

  PRINT# 3, "------------------  END  ----------------------"

  PRINT# 3, $FF 'start a new page  CHR$(12)
  PRINT# 3, "-------   Cross Reference List   --------- FOR:      "; inFile$
  PRINT# 3, ""

  PRINT: PRINT
  COLOR %GRN
  PRINT "Processing INCLUDE Search & Format Instructions:"

  GOSUB OutputXREF 'Print out the XREF List

  PRINT# 3, "------------------  END OF XREF ----------------------"
  PRINT# 3, ""
  PRINT# 3, "                User Defined Directives"
  PRINT# 3, "%MAX =" %MAX; "  tLabels& =" tLabels&; "  maxLineLen& =" maxLineLen&; "  XREF.DEF " xdef$; " used."
  PRINT# 3, "indentStart& =" indentStart&; "  indentSize& =" indentSize&; "  ignoreCase& =" ignoreCase&;
  PRINT# 3, ""
  PRINT# 3, "Reference Letter KEY: F. = Function,      S. = Sub          "
  PRINT# 3, "                      L. = Label,         X. = External Call"
  PRINT# 3, "       GK = Global constant,       GV = Global variable"
  PRINT# 3, "       .V = Local variable,        SV = Static variable"
  PRINT# 3, "       PR = Passed BYREF           PC = Passed BYCOPY"
  PRINT# 3, "       PV = Passed BYVAL           X. = Extern. K/VAR/SUB/FUNC"
  PRINT# 3, "       VT = Variable TYPE'd               (e.g. XK,XV,XS,XF)"
  PRINT# 3, "                    '*' indicates where reference is defined."
  CLOSE 3

  IF formatFLAG& = 0 THEN 'Retain original source
    PRINT "TST->BAK              0->TST"
    CALL MakeBAK(outFile$, "BAK")
  ELSEIF formatFLAG& = 1 THEN 'Use new format      'BAS->BAK    TST->BAS  0->TST
    PRINT RIGHT$(inFile$, 3); "->BAK    TST->"; RIGHT$(inFile$, 3); "  0->TST"
    CALL MakeBAK(inFile$, "BAK")
    CALL MakeBAK(outFile$, RIGHT$(infile$, 3))'.BAS, .INC or ???
  END IF
  PRINT
  CURSOR ON
  t2& = TIMER 'end time
  COLOR %BWHT: PRINT "Time to do job =>" t2& - t1& " secs"

100 CURSOR ON: COLOR %WHT
  COLOR %YEL: PRINT: PRINT "Hit any KEY to Exit";
  WAITKEY$
  EXIT FUNCTION

OutputXREF:  'label, reference
  nLabels& = 0 'wait till later
  PRINT# 3, "FUNCTION/SUBS:"

  PRINT# 3, SPACE$(tabSize& - 1) "Type  Start-Ending   "; '
  IF tabSize& < 10 THEN PRINT# 3, SPACE$(2); 'ELSE PRINT# 3, SPACE$(tabSize& - 14+2);
  PRINT# 3, "Reference Linenumbers"
  PRINT# 3, STRING$(tabSize& + 50, "-")
  FOR ii& = 1 TO VAL(gFS$(0))
    IF gSE$(ii&) < > "" THEN
      tabG& = LEN(gSE$(ii&))+ 5
      PRINT# 3, FormatXREFLine$(gFS$(ii&), gSE$(ii&) + SPACE$(5) + gFSref$(ii&))
      tabG& = 0
      tLabels& = tLabels& + 1
      nLabels& = nLabels& + 1
    END IF
  NEXT ii&
  PRINT# 3, ""
  PRINT# 3, SPACE$(5); "(" nLabels& ") Routines"
  PRINT# 3, "": nLabels& = 0

  PRINT# 3, "EXTERNAL INCLUDES: ";

  ii& = 1: IF externals$(ii&) = "" THEN PRINT# 3, "NONE"
  DO WHILE externals$(ii&) < > ""
    PRINT# 3, CHR$(34) externals$(ii&) CHR$(34)
    tLabels& = tLabels& + 1
    nLabels& = nLabels& + 1
    PRINT# 3, SPACE$(19);
    ii& = ii& + 1
  LOOP
  PRINT #3, ""
  IF nLabels& > 0 THEN
    PRINT# 3, SPACE$(5); "(" nLabels& ") Include"
    PRINT# 3, "": nLabels& = 0
  END IF
  PRINT# 3, ""

  PRINT# 3, "GLOBALS: ";

  IF VAL(gVar$(0))= 0 THEN
    PRINT# 3, " NONE": nLabels& = 0
  ELSE
    PRINT# 3, ""
    PRINT# 3, "Ref Labels";
    IF tabSize& < 10 THEN PRINT# 3, SPACE$(2); ELSE PRINT# 3, SPACE$(tabSize& - 10 + 2);
    PRINT# 3, "Reference Linenumbers"
    PRINT# 3, "-----------------------------------------------"

    ii& = 1: nLabels& = 0
LLoop1:
    IF gVar$(ii&) < > "" THEN
      PRINT# 3, FormatXREFLine$(gVar$(ii&), gRef$(ii&))
      tLabels& = tLabels& + 1
      nLabels& = nLabels& + 1
      ii& = ii& + 1
      GOTO LLoop1
    END IF
    PRINT# 3, ""
    PRINT# 3, SPACE$(5); "(" nLabels& ") globals"
    PRINT# 3, "": nLabels& = 0
  END IF

  IF Exist&("XREF.TMP") = 0 THEN 'The case where no SUBs/FUNCTIONs exist
    PRINT #3, "FUNCTIONS/SUBS:  NONE": RETURN
  END IF

  OPEN "XREF.TMP" FOR INPUT AS #4
  WHILE NOT EOF(4)
    LINE INPUT #4, rawLine$
    IF LEFT$(rawLine$, 12) = "FUNCTION/SUB" THEN
      tLabels& = tLabels& - 1
      IF nLabels& > 0 THEN
        PRINT# 3, SPACE$(5); "(" nLabels& - 1 ") labels"
        PRINT# 3, ""
      END IF
      PRINT# 3, ""
      PRINT# 3, rawLine$
      PRINT# 3, "Ref Labels";
      IF tabSize& < 10 THEN PRINT# 3, SPACE$(2); ELSE PRINT# 3, SPACE$(tabSize& - 10 + 2);
      PRINT# 3, "Reference Linenumbers"
      PRINT# 3, "-----------------------------------------------"
      nLabels& = 0
    ELSE
      fLabel$ = EXTRACT$(rawLine$, " ")
      fRef$ = REMAIN$(rawLine$, " ")
      PRINT# 3, FormatXREFLine$(fLabel$, fRef$)
      tLabels& = tLabels& + 1: nLabels& = nLabels& + 1
    END IF
  WEND
  CLOSE 4
  PRINT# 3, SPACE$(5); "(" nLabels& - 1 ") labels"
  PRINT# 3, ""
  tLabels& = tLabels& - 1
  KILL "XREF.TMP" '''Clean up directory doesn't hurt to REM this out if problems
RETURN

ErrorHandler:
  BEEP
  erCode& = ERR
  RESUME DisplayCode

DisplayCode:
  PRINT "":
  PRINT "": COLOR %RED
  PRINT "Error code";: COLOR %YEL: PRINT erCode&;
  COLOR %RED: PRINT " (REF Chapter 10 in PB Manual)"
  PRINT "was found while processing Linenumber ";
  COLOR %YEL: PRINT lineNumber&: COLOR %RED
  PRINT "of your original source code located in ";
  COLOR %YEL: PRINT inFile$;: COLOR %RED: PRINT "."
  GOTO 100

END FUNCTION

'------------------------------------------------------------
SUB UpdateFS(BYVAL laybel$, BYVAL strtEnd$, BYVAL ref$)
'       Define FUNCTION/SUB range and Global Calls

  LOCAL ii&, kk&
  LOCAL case1&, case2&, case3&, case4&

  ii& = 1: kk& = VAL(gFS$(0))
LoopF:
  case1& = (ignoreCase& = 0 AND laybel$ < gFS$(ii&))
  case2& = (ignoreCase& AND laybel$ < gFS$(ii&))

  case3& = (ignoreCase& = 0 AND laybel$ = gFS$(ii&))
  case4& = (ignoreCase& AND UCASE$(laybel$) = UCASE$(gFS$(ii&)))

  IF gFS$(ii&) = "" THEN '() add functions & arrays
    gFS$(ii&) = laybel$
    gSE$(ii&) = strtEnd$
    gFSref$(ii&) = ref$
    kk& = kk& + 1
  ELSEIF case1& OR case2& THEN 'laybel<gFS$
    ARRAY INSERT gFS$(ii&), laybel$
    ARRAY INSERT gSE$(ii&), strtEnd$
    ARRAY INSERT gFSref$(ii&), ref$
    kk& = kk& + 1
  ELSEIF case3& OR case4& THEN 'laybel=gFS$
    gSE$(ii&) = gSE$(ii&) + strtEnd$ 'This should only be defined once
    gFSref$(ii&) = gFSref$(ii&) + ref$
  ELSE
    ii& = ii& + 1
    GOTO LoopF
  END IF
  gFS$(0) = STR$(kk&)
  IF declareFLAG& > 1 THEN declareFLAG& = 10
END SUB

'-------------------------------------------------
SUB UpdateGlobals(BYVAL laybel$, BYVAL ref$, BYREF varType$)
'       Define global definitions and calls
'ref$ is the line number where laybel$ resides

  LOCAL ii&, kk&
  LOCAL case1&, case2&, case3&, case4&
  LOCAL star$

  star$ = "*": IF insideFLAG& = 1 THEN star$ = ""

  IF declareFLAG& THEN
    star$ = "*"
    declareFLAG& = 10
  END IF

  IF laybel$ = fsName$ THEN EXIT SUB

  ii& = 1: kk& = VAL(gVar$(0))
LoopG:
  case1& = (ignoreCase& = 0 AND laybel$ < gVar$(ii&))
  case3& = (ignoreCase& = 0 AND laybel$ = gVar$(ii&))
  case2& = (ignoreCase& AND (UCASE$(laybel$) < UCASE$(gVar$(ii&))))
  case4& = (ignoreCase& AND (UCASE$(laybel$) = UCASE$(gVar$(ii&))))

  IF gVar$(ii&) = "" THEN 'insert GLOBAL laybel$ and ref$
    gVar$(ii&) = laybel$
    gRef$(ii&) = varType$ + ref$ + star$
    kk& = kk& + 1
  ELSEIF case1& OR case2& THEN 'laybel$<gRef$(ii&) 'add arrays and get rid of them later
    ARRAY INSERT gVar$(ii&), laybel$
    ARRAY INSERT gRef$(ii&), varType$ + ref$ + star$
    kk& = kk& + 1
  ELSEIF case3& OR case4& THEN 'laybel$=gRef$(ii&)
    gRef$(ii&) = gRef$(ii&) + ref$
  ELSE
    ii& = ii& + 1
    GOTO LoopG
  END IF
  gVar$(0) = STR$(kk&)
END SUB

'----------------------------------
SUB UpdateLocals(BYVAL laybel$, BYVAL ref$, BYREF varType$)
'       Define LOCAL definitions and calls
'ref$ is the line number where laybel$ resides

  LOCAL ii&, kk&, variable$
  LOCAL case1&, case2&, case3&, case4&
  LOCAL case5&, case6&, case5A&, case6A&
  LOCAL case7&, case8&, case9&, case0&
  LOCAL case7A&, case8A&, case9A&, case0A&
  LOCAL rType$, star$ ''TBD

  IF laybel$ = fsName$ THEN EXIT SUB

  IF varType$ = "VT " THEN CALL UpdateGlobals(laybel$, ref$, "VT "): GOTO SkipGlobal
''' note the above line for TYPES that are internal and external ??? '''

  IF varType$ = "" AND callLine& = 1 THEN
    IF paramFLAG& < 2 THEN varType$ = "PR "
    IF paramFLAG& = 2 THEN varType$ = "PV "
    IF paramFLAG& = 3 THEN varType$ = "PC "
  END IF

'         Look in FUNCTIONS/SUBS for vType, eg. "F. " and update reference
  FOR ii& = 1 TO VAL(gFS$(0))

    case7& = (ignoreCase& = 0) AND (laybel$ = gFS$(ii&) AND gSE$(ii&) < > "")
    case8& = (ignoreCase& AND UCASE$(laybel$) = UCASE$(gFS$(ii&))AND gSE$(ii&) < > "")
    case9& = (ignoreCase& = 0) AND (laybel$ + "()" = gFS$(ii&) AND gSE$(ii&) < > "")
    case0& = (ignoreCase& AND UCASE$(laybel$ + "()") = UCASE$(gFS$(ii&))AND gSE$(ii&) < > "")

    case7A& = (ignoreCase& = 0) AND laybel$ < gFS$(ii&)
    case8A& = (ignoreCase& AND UCASE$(laybel$) < UCASE$(gFS$(ii&)))
    case9A& = (ignoreCase& = 0) AND (laybel$ + "()" < gFS$(ii&))
    case0A& = (ignoreCase& AND UCASE$(laybel$ + "()") < UCASE$(gFS$(ii&)))

    IF case7& OR case8& OR case9& OR case0& THEN 'laybel$=gFS$(ii&)
      rType$ = LEFT$(gSE$(ii&), 3): IF ASC(rType$) = 32 THEN rType$ = "" 'S/B 'F. ' or 'S. '
      IF varType$ = "" THEN varType$ = rType$
      EXIT FOR
    ELSEIF case7A& OR case8A& OR case9A& OR case0A& THEN 'laybel$<gFS$(ii&)
      EXIT FOR
    END IF
  NEXT ii&

  FOR ii& = 1 TO VAL(gVar$(0))
    case5& = (ignoreCase& = 0) AND (laybel$ = gVar$(ii&))
    case6& = (ignoreCase&) AND (UCASE$(laybel$) = UCASE$(gVar$(ii&)))

    case5A& = (ignoreCase& = 0) AND (laybel$ < gVar$(ii&))
    case6A& = (ignoreCase&) AND (UCASE$(laybel$) < UCASE$(gVar$(ii&)))

    IF case5& OR case6& THEN 'laybel$ =
      varType$ = LEFT$(gRef$(ii&), 3)
      IF ASC(varType$) = 32 THEN varType$ = "" 'S/B 'GV '
      IF LEFT$(laybel$, 1) < > "$" THEN gRef$(ii&) = gRef$(ii&) + ref$
      EXIT FOR
    ELSEIF case5A& OR case6A& THEN 'laybel <
      EXIT FOR
    END IF
  NEXT ii&

  IF ASC(varType$) = 76 THEN 'L
    IF varType$ = "L1 " OR varType$ = "L2 " OR varType$ = "L3 " THEN
      star$ = "*"
      varType$ = "L. "
    ELSE
      star$ = ""
      varType$ = ""
    END IF
  END IF

  variable$ = "$&%@?!#"
  IF varType$ = "" AND INSTR(RIGHT$(laybel$, 1), ANY variable$) THEN
    varType$ = ".V "
  ELSEIF varType$ = "" AND INSTR(laybel$, ".") THEN
    varType$ = ".V "
  END IF

SkipGlobal:
  ii& = 1: kk& = VAL(term$(0))
LoopL:
  case1& = (ignoreCase& = 0 AND laybel$ < term$(ii&))
  case2& = (ignoreCase& AND UCASE$(laybel$) < UCASE$(term$(ii&)))
  case3& = (ignoreCase& = 0 AND laybel$ = term$(ii&))
  case4& = (ignoreCase& AND UCASE$(laybel$) = UCASE$(term$(ii&)))

  IF term$(ii&) = "" THEN
    term$(ii&) = laybel$
    xRef$(ii&) = varType$ + ref$ + star$
    kk& = kk& + 1
  ELSEIF case1& OR case2& THEN 'laybel$<
    ARRAY INSERT term$(ii&), laybel$
    ARRAY INSERT xRef$(ii&), varType$ + ref$ + star$
    kk& = kk& + 1
  ELSEIF case3& OR case4& THEN 'laybel$=
    rType$ = LEFT$(xRef$(ii&), 3): IF ASC(rType$) = 32 THEN rType$ = ""
    IF rType$ = "" THEN
      xRef$(ii&) = varType$ + xRef$(ii&) + ref$ + star$
    ELSE
      xRef$(ii&) = xRef$(ii&) + ref$
    END IF
  ELSE
    ii& = ii& + 1: 'set up trap for exceeding %MAX
    GOTO LoopL
  END IF
  term$(0) = STR$(kk&)
  paramFLAG& = 0
END SUB

'----------------------------------------------
FUNCTION UpdateType&(BYVAL laybel$, BYVAL ref$)
'
'ref$ is the series of line numbers where laybel$ resides
'if defined then exit
'if not defined, try to define it, by looking at S/F, Globals, and Externals

  LOCAL ii&, vType$
  LOCAL case5&, case6&, case5A&, case6A&
  LOCAL case7&, case8&, case9&, case0&
  LOCAL case7A&, case8A&, case9A&, case0A&

  IF ASC(ref$) < > 32 THEN FUNCTION = 1: EXIT FUNCTION

'               Look in FUNCTIONS/SUBS for vType, eg. "F. "
  FUNCTION = 0
  FOR ii& = 1 TO VAL(gFS$(0))
    case7& = (ignoreCase& = 0) AND (laybel$ = gFS$(ii&) AND gSE$(ii&) < > "")
    case8& = (ignoreCase& AND UCASE$(laybel$) = UCASE$(gFS$(ii&))AND gSE$(ii&) < > "")

    case9& = (ignoreCase& = 0) AND (laybel$ + "()" = gFS$(ii&) AND gSE$(ii&) < > "")
    case0& = (ignoreCase& AND UCASE$(laybel$ + "()") = UCASE$(gFS$(ii&))AND gSE$(ii&) < > "")

    case7A& = (ignoreCase& = 0) AND laybel$ < gFS$(ii&)
    case8A& = (ignoreCase& AND UCASE$(laybel$) < UCASE$(gFS$(ii&)))

    case9A& = (ignoreCase& = 0) AND (laybel$ + "()" < gFS$(ii&))
    case0A& = (ignoreCase& AND UCASE$(laybel$ + "()") < UCASE$(gFS$(ii&)))
    IF case7& OR case8& OR case9& OR case0& THEN 'laybel$=gFS$(ii&)
      vType$ = LEFT$(gSE$(ii&), 3)
      IF ASC(vType$) < > 32 THEN ref$ = vType$ + ref$: FUNCTION = 1: EXIT FUNCTION
    ELSEIF case7A& OR case8A& OR case9A& OR case0A& THEN
      EXIT FOR 'Terminate search if laybel is bigger
    END IF
  NEXT ii&

'           Not found, try searching Global area type
  FOR ii& = 1 TO VAL(gVar$(0))'Look in Globals, eg. "GK " or "GV "
    case5& = (ignoreCase& = 0) AND (laybel$ = gVar$(ii&))
    case6& = (ignoreCase&) AND (UCASE$(laybel$) = UCASE$(gVar$(ii&)))

    case5A& = (ignoreCase& = 0) AND (laybel$ < gVar$(ii&))
    case6A& = (ignoreCase&) AND (UCASE$(laybel$) < UCASE$(gVar$(ii&)))
    IF case5& OR case6& THEN
      vType$ = LEFT$(gRef$(ii&), 3)
      IF ASC(vType$) < > 32 THEN ref$ = vType$ + ref$: FUNCTION = 1: EXIT FUNCTION
    ELSEIF case5A& OR case6A& THEN 'Terminate search if laybel is smaller
      EXIT FOR
    END IF
  NEXT ii&
END FUNCTION 'Not found at this exit

'---------------------------------- EOF ------------------------------------


